﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;
using Microsoft.Exchange.WebServices.Data;
using System.Net;
using System.IO;
using System.Diagnostics;

namespace EnLBarCodeEmailChecker
{
    class Program
    {
        static void Main(string[] args)
        {
            string conn = ConfigurationManager.AppSettings["conn"];
            string serviceUrl = ConfigurationManager.AppSettings["service"];
            string pathIn = ConfigurationManager.AppSettings["pathIn"];
            string email = ConfigurationManager.AppSettings["email"];
            string password = ConfigurationManager.AppSettings["password"];
            string time = ConfigurationManager.AppSettings["time"];

            log log = new log();

            while (true)
            {
                try
                {
                    string strMachineName = Environment.MachineName;
                    log.EventViewerLog("Registering Exchange connection", "EmailService.Working", false);
                    Console.WriteLine("Registering Exchange connection :EmailService.Working");

                    if (strMachineName == "DXLBEBIZTKD08" || strMachineName == "ENL")
                    {
                        Console.WriteLine("email: " + email + " :EmailService.Working");
                        Console.WriteLine("uri: " + serviceUrl + " :EmailService.Working");

                        log.EventViewerLog("email: " + email, "EmailService.Working", false);
                        log.EventViewerLog("uri: " + serviceUrl, "EmailService.Working", false);
                    }

                    ExchangeService service = new ExchangeService
                    {
                        Credentials = new WebCredentials(email, password)
                    };
                    System.Net.ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls12;

                    log.EventViewerLog("1: Before Connected", "EmailService.Working", false);
                    Console.WriteLine("1: Before Connected :EmailService.Working");

                    service.Url = new Uri(serviceUrl);
                    log.EventViewerLog("2: Connected", "EmailService.Working", false);
                    Console.WriteLine("2: Connected :EmailService.Working");

                    // Read 100 mails
                    FindItemsResults<Item> result = service.FindItems(WellKnownFolderName.Inbox, new ItemView(100));
                    log.EventViewerLog("3: ", "EmailService.Working", false);
                    Console.WriteLine("3: Connected :EmailService.Working");

                    foreach (Item item in result.Items)
                    {
                        item.Load();
                        log.EventViewerLog("4: item " + item.Subject.ToString(), "EmailService.Working", false);
                        Console.WriteLine("4: item " + item.Subject.ToString() + " :EmailService.Working");

                        if (item.HasAttachments)
                        {
                            foreach (var i in item.Attachments)
                            {
                                FileAttachment fileAttachment = i as FileAttachment;
                                fileAttachment.Load();
                                Console.WriteLine("FileName: " + fileAttachment.Name);
                                File.WriteAllBytes(pathIn + fileAttachment.Name, fileAttachment.Content);
                            }
                        }
                        log.EventViewerLog("5: Attachments", "EmailService.Working", false);
                        Console.WriteLine("5: Attachments :EmailService.Working");

                        FolderId idBackup = getFolderId("Backup", service);
                        log.EventViewerLog("6:idBackup " + idBackup.ToString(), "EmailService.Working", false);
                        Console.WriteLine("6:idBackup " + idBackup.ToString() + " :EmailService.Working");

                        if (idBackup.FolderName.ToString() == "Root")
                        {
                            //Crea il folder Backup
                            Folder folder = new Folder(service);
                            folder.DisplayName = "Backup";
                            folder.FolderClass = "IPF.Note";
                            // Save the folder as a child folder of the Inbox.
                            folder.Save(WellKnownFolderName.Inbox);
                            idBackup = getFolderId("Backup", service);
                        }
                        log.EventViewerLog("7: ", "EmailService.Working", false);
                        Console.WriteLine("7:  :EmailService.Working");

                        item.Move(idBackup);
                        log.EventViewerLog("8:Move " + idBackup.ToString(), "EmailService.Working", false);
                        Console.WriteLine("8:Move " + idBackup.ToString() + " :EmailService.Working");

                        if (strMachineName == "DXLBEBIZTKD08" || strMachineName == "ENL")
                        {
                            log.EventViewerLog("Move to Backup Folder.", "EmailService.Working", false);
                            Console.WriteLine("Move to Backup Folder. :EmailService.Working");

                        }
                    }
                }
                catch (Exception ex)
                {
                    log.EventViewerLog("Message: " + ex.Message + " source:" + ex.Source, "EmailService.Working", true);
                    Console.WriteLine("Message: " + ex.Message + " source:" + ex.Source + " :EmailService.Working");

                }
                //minutes
                System.Threading.Thread.Sleep(60000 * (int.Parse(time)));
            }

        }

        static FolderId getFolderId(string folderName, ExchangeService service)
        {
            try
            {
                // Create a view with a page size of 10.
                FolderView view = new FolderView(1);

                // Identify the properties to return in the results set.
                view.PropertySet = new PropertySet(FolderSchema.Id);
                view.PropertySet.Add(FolderSchema.DisplayName);

                // Return only folders that contain items.
                SearchFilter searchFilter = new SearchFilter.IsEqualTo(FolderSchema.DisplayName, folderName);

                // Unlike FindItem searches, folder searches can be deep traversals.
                view.Traversal = FolderTraversal.Deep;

                // Send the request to search the mailbox and get the results.
                FindFoldersResults findFolderResults = service.FindFolders(WellKnownFolderName.Root, searchFilter, view);

                if (findFolderResults.TotalCount > 0)
                {
                    return findFolderResults.Folders[0].Id;
                }
            }
            catch (Exception ex)
            {
                log log = new log();
                log.EventViewerLog("getFolderId failed. error: " + ex.Message, "EmailService.getFolderId", true);
            }

            return new FolderId(WellKnownFolderName.Root);
        }
    }
    [Serializable]
    public class log
    {
       public void EventViewerLog(string message, string source, bool error)
        {

            EventLog evt = new EventLog();
            try
            {
                evt.Source = source;
                if (error)
                    evt.WriteEntry("error: " + message, EventLogEntryType.Error);
                else
                    evt.WriteEntry("Elaboration correct: " + message, EventLogEntryType.Information);


            }
            catch (Exception ex)
            {
                evt.Source = "log.EventViewerLog";
                evt.WriteEntry("error: " + ex.Message, EventLogEntryType.Error);
            }


        }
    }

}
